package mangareader;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import javax.swing.*;

import java.io.*;
import javax.imageio.*;
import javax.swing.JOptionPane;

public class ImagePage extends JPanel{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Image img;
	BufferedImage bimg;
	JLabel label ;
	public boolean startup = true;
	private boolean widthwise = true;
	
	public ImagePage(){
		ImageIcon ico = new ImageIcon("");
		label = new JLabel("",ico,JLabel.CENTER);
		 GridBagLayout gbl = new GridBagLayout();
		 GridBagConstraints gbc = new GridBagConstraints();
		 setLayout(gbl);
		 gbc.fill = GridBagConstraints.BOTH;
		 gbl.setConstraints(label, gbc);
		 add(label);
		
		
	}
	public void setImage(String str){
		
		File f = new File(str);
		try{
			 img = ImageIO.read(f);
			}catch(Exception e){
				JOptionPane.showMessageDialog(this,"not able to load image");
				//System.out.println(e);
				return;
			}	
		if(!startup){	 
		updatePaint();
		ImageIcon ico = new ImageIcon(bimg);
		label.setIcon(ico);
		}else{
			bimg  = resize(img,width,height);
			ImageIcon ico = new ImageIcon(bimg);
			label.setIcon(ico);
			//setting image width and height according to the moniter size
		}
	}
	private int width=50;
	private int height=50;
	private void updatePaint(){
		if(img != null){
			int x ;
			x = 1500;
			int y = getImgy(x);
			bimg = resize(img,x,y);
			bimg = blur(bimg);
			if(widthwise){
			x = width;
			y = getImgy(x);
			}
			else{
				y = height;
				x = getImgx(y);
			}
			
			bimg = resize(bimg,x,y);
		}
	}
	public void setWidthWise(){
		widthwise = true;
	}
	public void setHeightWise(){
		widthwise = false;
	}
	public void setWidthHeight(int width,int height){
		this.width = width;
		this.height = height;
	}
	private int getImgx(int y){
		int x;
		x = img.getWidth(null)*y;
		x = x/img.getHeight(null);
		return x;
	}
	private int getImgy(int x){
		int y;
		y = img.getHeight(null)*x;
		y= y/img.getWidth(null);
		return y;
	}
	
	private BufferedImage blur(BufferedImage img){
		float weight = 1.0f/9.0f;
		float[] elements = new float[9];
		for(int i=0;i<9;i++)
			elements[i] = weight;
		Kernel kernel = new Kernel(3,3,elements);
		ConvolveOp op = new ConvolveOp(kernel);
		if(img != null)
			img = op.filter(img,null);
		return img;
	}
	
	private BufferedImage resize(BufferedImage img,int x,int y){
		BufferedImage image = new BufferedImage(x,y,BufferedImage.TYPE_INT_ARGB);
		image.getGraphics().drawImage(img, 0, 0, x, y, null);
		return image;
	}
	private BufferedImage resize(Image img,int x,int y){
		BufferedImage image = new BufferedImage(x,y,BufferedImage.TYPE_INT_ARGB);
		image.getGraphics().drawImage(img, 0, 0, x, y, null);
		return image;
	}

}
