package mangareader;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.filechooser.*;


public class MangaReader extends JFrame 
{
	JButton browse ; 
	ImagePage pagepane;
	JMenuItem menuItem;
	Dimension dim;
	FileControler container;
	JScrollPane pagesc;
	final JFileChooser fc;
	boolean loaded =false;
	JMenuItem pageno;
 public MangaReader(){
	 dim = getToolkit().getScreenSize();
	 setSize(dim.width,dim.height);
	 fc = new JFileChooser();
	 container = new FileControler();
	 fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	 setUpMenu();
	 pagepane = new ImagePage();
	 pagepane.setWidthHeight(dim.width-20,dim.height-90);
	 pagepane.setWidthWise();
	 pagepane.startup = true;
	 //pagepane.setImage(System.getProperty("user.dir")+"\\src\\mangareader\\background.jpg");
	 pagepane.setImage("background.jpg");
	 pagesc = new JScrollPane(pagepane);
	  pagesc.getVerticalScrollBar().setUnitIncrement(16);
	  pagesc.getHorizontalScrollBar().setUnitIncrement(16);
	 add(pagesc);
	
 }
 public void setUpMenu(){
	 JMenuBar mbar = new JMenuBar();
	 setJMenuBar(mbar);
	 JMenu file = new JMenu("File");
	// ImageIcon icon =new ImageIcon("browse.png");
	// JMenuItem menuItem = new JMenuItem("open directory",icon);
	 JMenuItem menuItem = new JMenuItem("open directory");
	 JMenuItem menuexit = new JMenuItem("Exit");
	 JMenu view = new JMenu("View");
	 JMenuItem gotopage = new JMenuItem("Page");
	 JMenu orientation = new JMenu("Orientation");
	 JMenuItem widthwise = new JMenuItem("Width Wise");
	 JMenuItem heightwise = new JMenuItem("Height Wise");
	 JMenu getPageno  = new JMenu(" Current Page");
	 pageno = new JMenuItem("");
	 menuItem.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent ae){
			 int rval = fc.showOpenDialog(MangaReader.this);
			 if(rval == JFileChooser.APPROVE_OPTION){
				 pagepane.startup = false;
				 File file = fc.getSelectedFile();
				 FilenameFilter only = new onlyext(); 
				 if(file.isDirectory()){
					 container.setFileNames(file.getAbsolutePath(),file.list(only));
					 pagepane.setImage(container.getCurrentFile());
					 refresh();
					 createPopupMenu();
					 loaded = true;
					 pageno.setText(container.getCurrentFileIndex());
					 setTitle(container.title);
				 }else{
					 JOptionPane.showMessageDialog(MangaReader.this,file.getName());
				 }
			 }
		 }
	 });
	 
	 menuexit.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent ae){
			 System.exit(0);
		 }
	 });
	
	 gotopage.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent ae){
			 if(loaded){
				 String temp = JOptionPane.showInputDialog(MangaReader.this,"enter page number between 1 to "+container.getNoOfFiles(),"",JOptionPane.PLAIN_MESSAGE);
				 try{
					 temp = temp.trim();
				 }catch(Exception e){
					 
				 }
				 int index=0;
				 try{
					 index= Integer.parseInt(temp);
					 index--;
					 if(index >=0 && index <container.getNoOfFiles()){
						 pagepane.setImage(container.fileAtIndex(index));
						 refresh();
						 pageno.setText(container.getCurrentFileIndex());
					 }
					 else{
						 JOptionPane.showMessageDialog(MangaReader.this,"page number is not in range");
					 }
				 }catch(Exception e){
				 JOptionPane.showMessageDialog(MangaReader.this,"page number is not in range");
				 }
			 }
		 }
	 });
	 
	 widthwise.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent e){
			 if(loaded){
			 pagepane.setWidthWise();
			 pagepane.setImage(container.getCurrentFile());
			 refresh();}
		 }
	 });
	 heightwise.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent e){
			 if(loaded){
			 pagepane.setHeightWise();
			 pagepane.setImage(container.getCurrentFile());
			 refresh();}
		 }
	 });
	 getPageno.add(pageno);
	 file.add(menuItem);
	 file.add(menuexit);
	 view.add(gotopage);
	 orientation.add(widthwise);
	 orientation.add(heightwise);
	 view.add(orientation);
	 view.add(getPageno);
	 mbar.add(file);
	 mbar.add(view);
	 
	 
 }
 
private void refresh(){
	JViewport jv = (JViewport) pagepane.getParent();
	 jv.setViewPosition(new Point(0, 0));
}
 private void createPopupMenu() {
     JMenuItem menuItem;

     //Create the popup menu.
     JPopupMenu popup = new JPopupMenu();
     menuItem = new JMenuItem("Next");
     menuItem.addActionListener(new ActionListener(){
    	 public void actionPerformed(ActionEvent e){
    		 pagepane.setImage(container.getNext());
    		 refresh();
    		 pageno.setText(container.getCurrentFileIndex());
    	 }
     });
     popup.add(menuItem);
     menuItem = new JMenuItem("Previous");
     menuItem.addActionListener(new ActionListener(){
    	 public void actionPerformed(ActionEvent e){
    		 pagepane.setImage(container.getPrevious());
    		 refresh();
    		 pageno.setText(container.getCurrentFileIndex());
    	 }
     });
     popup.add(menuItem);

     //Add listener to the text area so the popup menu can come up.
     MouseListener popupListener = new PopupListener(popup);
     pagepane.addMouseListener(popupListener);
 }
 public static void main( String args[] )
 {
		EventQueue.invokeLater(new Runnable(){
			public void run(){
				MangaReader frame = new MangaReader();
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setTitle("Manga Reader");
				//frame.setSize(1024,720);
				//frame.setResizable(false);
				frame.setVisible(true);
				
			}
			
		});
 }
 
 class PopupListener extends MouseAdapter {
     JPopupMenu popup;

     PopupListener(JPopupMenu popupMenu) {
         popup = popupMenu;
     }

     public void mousePressed(MouseEvent e) {
         maybeShowPopup(e);
     }

     public void mouseReleased(MouseEvent e) {
         maybeShowPopup(e);
     }

     private void maybeShowPopup(MouseEvent e) {
         if (e.isPopupTrigger()) {
             popup.show(e.getComponent(),
                        e.getX(), e.getY());
         }
     }
 }
 
 class onlyext implements FilenameFilter{
	 String ext ="jpg";
	 String ext2 = "JPG";
	 public onlyext(){
		 
	 }
	 public boolean accept(File directory,String name){
		 return (name.endsWith(ext)||name.endsWith(ext2));
	 }
 }
}  
